#!/usr/bin/perl -w 

use Test::Simple tests => 33;

use BioGraph::Analyze;
use BioGraph::Clustering;
use BioGraph::Compute;
use BioGraph::FileAccess;
use BioGraph::Operation;
use BioGraph::Random;
use BioGraph::Visual;

ok(%G=BioGraph::FileAccess::read_graph("test_graph.gr", 1, 1), "FileAccess::read_graph()");
ok(BioGraph::FileAccess::read_association("test_graph.asso", 1, %G), "FileAccess::read_association()");
ok(BioGraph::FileAccess::write_graph(1, "test_write", "dot", %G), "FileAccess::write_graph()");
ok(BioGraph::Random::generate(1, 100, 4, "0.4 0.5 0.3 0.6", 0.1), "Random::generate()");
ok(BioGraph::Visual::display(1, %G), "Visual::display()");
ok(BioGraph::Visual::export(1, "test_write", "dot", %G), "Visual::export()");
ok(BioGraph::Analyze::vertices_list(1, %G), "Analyze::vertices_list()");
ok(BioGraph::Analyze::degree_distribution(1, %G), "Analyze::degree_distribution()");
ok(BioGraph::Operation::copy_graph(1, %G), "Operation::copy_graph()");
ok(BioGraph::Operation::symetric(1, %G), "Operation::symetric()");
ok(BioGraph::Operation::compute_CC(1, 0, "", %G), "Operation::compute_CC()");
ok(BioGraph::Compute::vertices_nb(1, %G), "Compute::vertices_nb()");
ok(BioGraph::Compute::edges_nb(1, %G), "Compute::edges_nb()");
ok(BioGraph::Compute::global_density(1, %G), "Compute::global_density()");
ok(%D=BioGraph::Compute::degree(1, %G), "Compute::degree()");
ok(BioGraph::Compute::mean(%D), "Compute::mean()");
ok(BioGraph::Compute::cluster_coeff(1, %G), "Compute::cluster_coeff()");
ok(BioGraph::Compute::triangle_nb(1, "2", "3", %G), "Compute::triangle_nb()");
ok(BioGraph::Compute::shortest_paths(1, "1", %G), "Compute::shortest_paths()");
ok(%Dist=BioGraph::Compute::distance(1, "Radicchi", %G), "Compute::distance()");
ok(BioGraph::Compute::maximal_distance(%Dist), "Compute::maximal_distance()");
ok(%Dens=BioGraph::Compute::distance2density(1, \%Dist, %G), "Compute::distance2density()");
ok(BioGraph::Operation::cut_edge(1, "1", "2", %G), "Operation::cut_edge()");
ok(BioGraph::Operation::cut_vertex(1, "1", %G), "Operation::cut_vertex()");
ok(%Clust=BioGraph::Clustering::ZD_kernel(1, \%Dens, %G), "Clustering::ZD_kernel()");
ok(BioGraph::Clustering::ZD_extension(1, \%Dens, \%Clust, %G), "Clustering::ZD_extension()");
ok(BioGraph::Compute::internal_density(1, $Clust{1}, %G), "Compute::internal_density()"); 
ok(BioGraph::Compute::external_density(1, 2, \%Clust, %G), "Compute::external_density()");
ok(%Ed=BioGraph::Compute::edge_density(1, \%Dens, %G), "Compute::edge_density()");
ok(BioGraph::Visual::generate_3D("test_3D", 1, \%Ed, %G), "Visual::generate_3D()");
ok(BioGraph::FileAccess::write_valuated_graph(1, "test_write", "dot", \%Dist, %G), "FileAccess::write_valuated_graph()");
ok(BioGraph::FileAccess::write_graph_clusters(1, "test_write", "dot", 2, \%Clust, %G), "FileAccess::write_graph_clusters()");
ok(BioGraph::FileAccess::write_treedyn_clusters("test_write", 2, \%Clust), "FileAccess::write_treedyn_clusters()");
